﻿// Copyright (c) Interactive Scientific LTD. All rights reserved.
// Licensed under the GPL. See License.txt in the project root for license information.
using System;
using System.Globalization;
using System.Xml;
using SlimMath;

namespace Nano
{
    /// <summary>
    /// Helper methods of all flavors.
    /// </summary>
    /// <autogeneratedoc />
    public static partial class Helper
    {
        /// <summary>
        /// Appends the attribute and value.
        /// </summary>
        /// <param name="element">The element.</param>
        /// <param name="name">The name.</param>
        /// <param name="value">The value.</param>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for AppendAttributeAndValue
        public static void AppendAttributeAndValue(XmlElement element, string name, Vector2 value) { AppendAttributeAndValue(element, name, SerializeVector2(value)); }
        
        /// <summary>
        /// Appends the attribute and value.
        /// </summary>
        /// <param name="element">The element.</param>
        /// <param name="name">The name.</param>
        /// <param name="value">The value.</param>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for AppendAttributeAndValue
        public static void AppendAttributeAndValue(XmlElement element, string name, Vector3 value) { AppendAttributeAndValue(element, name, SerializeVector3(value)); }
        
        /// <summary>
        /// Appends the attribute and value.
        /// </summary>
        /// <param name="element">The element.</param>
        /// <param name="name">The name.</param>
        /// <param name="value">The value.</param>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for AppendAttributeAndValue
        public static void AppendAttributeAndValue(XmlElement element, string name, Vector4 value) { AppendAttributeAndValue(element, name, SerializeVector4(value)); }
       
        /// <summary>
        /// Appends the attribute and value.
        /// </summary>
        /// <param name="element">The element.</param>
        /// <param name="name">The name.</param>
        /// <param name="value">The value.</param>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for AppendAttributeAndValue
        public static void AppendAttributeAndValue(XmlElement element, string name, Color4 value) { AppendAttributeAndValue(element, name, SerializeColor4(value)); }
       
        /// <summary>
        /// Appends the attribute and value.
        /// </summary>
        /// <param name="element">The element.</param>
        /// <param name="name">The name.</param>
        /// <param name="value">The value.</param>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for AppendAttributeAndValue
        public static void AppendAttributeAndValue(XmlElement element, string name, Quaternion value) { AppendAttributeAndValue(element, name, SerializeQuaternion(value)); }

        /// <summary>
        /// Gets the attribute value.
        /// </summary>
        /// <param name="node">The node.</param>
        /// <param name="name">The name.</param>
        /// <param name="default">The default.</param>
        /// <returns>Vector2.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for GetAttributeValue
        public static Vector2 GetAttributeValue(XmlNode node, string name, Vector2 @default)
        {
            if (node.Attributes[name] == null)
            {
                return @default;
            }

            try
            {
                return DeserializeVector2(node.Attributes[name].Value);
            }
            catch
            {
                return @default;
            }
        }

        /// <summary>
        /// Gets the attribute value.
        /// </summary>
        /// <param name="node">The node.</param>
        /// <param name="name">The name.</param>
        /// <param name="default">The default.</param>
        /// <returns>Vector3.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for GetAttributeValue
        public static Vector3 GetAttributeValue(XmlNode node, string name, Vector3 @default)
        {
            if (node.Attributes[name] == null)
            {
                return @default;
            }

            try
            {
                return DeserializeVector3(node.Attributes[name].Value);
            }
            catch
            {
                return @default;
            }
        }

        /// <summary>
        /// Gets the attribute value.
        /// </summary>
        /// <param name="node">The node.</param>
        /// <param name="name">The name.</param>
        /// <param name="default">The default.</param>
        /// <returns>Vector4.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for GetAttributeValue
        public static Vector4 GetAttributeValue(XmlNode node, string name, Vector4 @default)
        {
            if (node.Attributes[name] == null)
            {
                return @default;
            }

            try
            {
                return DeserializeVector4(node.Attributes[name].Value);
            }
            catch
            {
                return @default;
            }
        }

        /// <summary>
        /// Gets the attribute value.
        /// </summary>
        /// <param name="node">The node.</param>
        /// <param name="name">The name.</param>
        /// <param name="default">The default.</param>
        /// <returns>Color4.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for GetAttributeValue
        public static Color4 GetAttributeValue(XmlNode node, string name, Color4 @default)
        {
            if (node.Attributes[name] == null)
            {
                return @default;
            }

            try
            {
                return DeserializeColor4(node.Attributes[name].Value);
            }
            catch
            {
                return @default;
            }
        }

        /// <summary>
        /// Gets the attribute value.
        /// </summary>
        /// <param name="node">The node.</param>
        /// <param name="name">The name.</param>
        /// <param name="default">The default.</param>
        /// <returns>Quaternion.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for GetAttributeValue
        public static Quaternion GetAttributeValue(XmlNode node, string name, Quaternion @default)
        {
            if (node.Attributes[name] == null)
            {
                return @default;
            }

            try
            {
                return DeserializeQuaternion(node.Attributes[name].Value);
            }
            catch
            {
                return @default;
            }
        }



        /// <summary>
        /// Serializes the color4.
        /// </summary>
        /// <param name="color">The color.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for SerializeColor4
        public static string SerializeColor4(Color4 color)
        {
            return string.Format("{0},{1},{2},{3}",
                color.Alpha.ToString(CultureInfo.InvariantCulture), 
                color.Red.ToString(CultureInfo.InvariantCulture), 
                color.Green.ToString(CultureInfo.InvariantCulture), 
                color.Blue.ToString(CultureInfo.InvariantCulture));
        }

        /// <summary>
        /// Deserializes the color4.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <returns>Color4.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for DeserializeColor4
        public static Color4 DeserializeColor4(string value)
        {
            string[] parts = value.Split(',');

            float a, r, g, b;

            a = float.Parse(parts[0], CultureInfo.InvariantCulture);
            r = float.Parse(parts[1], CultureInfo.InvariantCulture);
            g = float.Parse(parts[2], CultureInfo.InvariantCulture);
            b = float.Parse(parts[3], CultureInfo.InvariantCulture);

            return new Color4(r, g, b, a);
        }



        #region Vectors

        /// <summary>
        /// Serializes the vector2.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for SerializeVector2
        public static string SerializeVector2(Vector2 value)
        {
            return String.Format("{0},{1}",
                value.X.ToString(CultureInfo.InvariantCulture),
                value.Y.ToString(CultureInfo.InvariantCulture));
        }

        /// <summary>
        /// Deserializes the vector2.
        /// </summary>
        /// <param name="str">The string.</param>
        /// <returns>Vector2.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for DeserializeVector2
        public static Vector2 DeserializeVector2(string str)
        {
            string[] pieces = str.Split(new char[] { ',' });
            float x, y;

            x = float.Parse(pieces[0], CultureInfo.InvariantCulture);
            y = float.Parse(pieces[1], CultureInfo.InvariantCulture);

            return new Vector2(x, y);
        }

        /// <summary>
        /// Serializes the vector3.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for SerializeVector3
        public static string SerializeVector3(Vector3 value)
        {
            return String.Format("{0},{1},{2}",
                value.X.ToString(CultureInfo.InvariantCulture),
                value.Y.ToString(CultureInfo.InvariantCulture),
                value.Z.ToString(CultureInfo.InvariantCulture));
        }

        /// <summary>
        /// Deserializes the vector3.
        /// </summary>
        /// <param name="str">The string.</param>
        /// <returns>Vector3.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for DeserializeVector3
        public static Vector3 DeserializeVector3(string str)
        {
            string[] pieces = str.Split(new char[] { ',' });
            float x, y, z;

            x = float.Parse(pieces[0], CultureInfo.InvariantCulture);
            y = float.Parse(pieces[1], CultureInfo.InvariantCulture);
            z = float.Parse(pieces[2], CultureInfo.InvariantCulture);

            return new Vector3(x, y, z);
        }

        /// <summary>
        /// Serializes the vector4.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for SerializeVector4
        public static string SerializeVector4(Vector4 value)
        {
            return String.Format("{0},{1},{2},{3}",
                value.X.ToString(CultureInfo.InvariantCulture),
                value.Y.ToString(CultureInfo.InvariantCulture),
                value.Z.ToString(CultureInfo.InvariantCulture),
                value.W.ToString(CultureInfo.InvariantCulture));
        }

        /// <summary>
        /// Deserializes the vector4.
        /// </summary>
        /// <param name="str">The string.</param>
        /// <returns>Vector4.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for DeserializeVector4
        public static Vector4 DeserializeVector4(string str)
        {
            string[] pieces = str.Split(new char[] { ',' });
            float x, y, z, w;

            x = float.Parse(pieces[0], CultureInfo.InvariantCulture);
            y = float.Parse(pieces[1], CultureInfo.InvariantCulture);
            z = float.Parse(pieces[2], CultureInfo.InvariantCulture);
            w = float.Parse(pieces[3], CultureInfo.InvariantCulture);

            return new Vector4(x, y, z, w);
        }

        /// <summary>
        /// Serializes the quaternion.
        /// </summary>
        /// <param name="value">The value.</param>
        /// <returns>System.String.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for SerializeQuaternion
        public static string SerializeQuaternion(Quaternion value)
        {
            return String.Format("{0},{1},{2},{3}",
                value.X.ToString(CultureInfo.InvariantCulture),
                value.Y.ToString(CultureInfo.InvariantCulture),
                value.Z.ToString(CultureInfo.InvariantCulture),
                value.W.ToString(CultureInfo.InvariantCulture));
        }

        /// <summary>
        /// Deserializes the quaternion.
        /// </summary>
        /// <param name="str">The string.</param>
        /// <returns>Quaternion.</returns>
        /// <autogeneratedoc />
        /// TODO Edit XML Comment Template for DeserializeQuaternion
        public static Quaternion DeserializeQuaternion(string str)
        {
            string[] pieces = str.Split(new char[] { ',' });
            float x, y, z, w;

            x = float.Parse(pieces[0], CultureInfo.InvariantCulture);
            y = float.Parse(pieces[1], CultureInfo.InvariantCulture);
            z = float.Parse(pieces[2], CultureInfo.InvariantCulture);
            w = float.Parse(pieces[3], CultureInfo.InvariantCulture);

            return new Quaternion(x, y, z, w);
        }

        #endregion
    }
}
